//=======================================================================
//  TARGET PROJECT: PSM3D(Prosessor Study Model3 DualCore)
//  TARGET SYSTEM : DEMO on Sp3StarterKit (PSM3D TARGET SYSTEM)
//  FUNCTION      : Multi Proseccor Binary Semaphoreiǂj
//
//                      Copyright (C) 2010 by Tomoyuki Inomoto
//=======================================================================
#include    "MpSem.h"

//============================================================================================================
//============================================================================================================
//  EXTERN
//============================================================================================================
//============================================================================================================
void BusLock(void);
void BusUnLock(void);

//============================================================================================================
//============================================================================================================
//  GLOBAL
//============================================================================================================
//============================================================================================================

//============================================================================================================
//============================================================================================================
//  PRIVATE
//============================================================================================================
//============================================================================================================

//============================================================================================================
//============================================================================================================
//  PROTOTYPE
//============================================================================================================
//============================================================================================================
//============================================================================================================
//============================================================================================================
//  BODY
//============================================================================================================
//============================================================================================================
//============================================================================================================
void MpSemInit(int *Sem)
//============================================================================================================
// [@\] Z}tHGIVEꂽԂŏ
// [] Z}tH̃AhXiLbV̈ł鎖j
// [Ԓl] 
{
    *Sem = 1;
}
//============================================================================================================
int MpSemTake(int *Sem)
//============================================================================================================
// [@\] Z}tHTAKE
// [] Z}tH̃AhXiLbV̈ł鎖j
// [Ԓl] FSEM_TAKE_OK, sFSEM_TAKE_NG
{
    int     Ret;
    
    BusLock();
    
    if(*Sem == 0){
        Ret = SEM_TAKE_NG;
    }
    else{
        *Sem = 0;
        Ret = SEM_TAKE_OK;
    }
    BusUnLock();
    return Ret;
}

//============================================================================================================
int MpSemGive(int *Sem)
//============================================================================================================
// [@\] Z}tHTAKE
// [] Z}tH̃AhXiLbV̈ł鎖j
// [Ԓl] FSEM_TAKE_OK(K)
{
    BusLock();
    *Sem = 1;
    BusUnLock();
    return SEM_TAKE_OK;
}
