//============================================================
//  TARGET SYSTEM : Psm3Core (Processor Study Model 3 Core)
//  FUNCTION      : Psm3 C Compiler (COMMON HEADER)
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================
//=====================================================================================================
//  o[W`
//=====================================================================================================
#define     VERSION_MAJOR       (0)
#define     VERSION_MINER       (0)
//#define     VERSION_SUB_MINER   (1)  // 20100228J
#define     VERSION_SUB_MINER   (2)  // 20100322J

//=====================================================================================================
//  IvV`
//=====================================================================================================
//#define     CC_MSGENABLE
#define     CC0_DEBUG   //vvZbTʏo(cc0_result.txt)
#define     CC1_DEBUG   //͌ʏo(cc1_result.txt)
#define     CC2_DEBUG   //\́R[hOo(cc2_log.txt)
#define     CC2_WARNING_ON //xo
//#define       ENABLE_DOUBLE // doubleLiΉ̈׃RgAEgj
//#define       ENABLE_FLOAT  // floatLiΉ̈׃RgAEgj
//#define       ENABLE_ENUM   // enumLiΉ̈׃RgAEgj

//=====================================================================================================
//  萔`
//=====================================================================================================
#define     P3CC_OK             (0)
#define     P3CC_NG             (-1)
#define     P3CC_ESCAPE         (-2)
#define     P3CC_TRUE           (1)
#define     P3CC_FALSE          (0)

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// vvZbT֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#define     MAX_SOURCE_LINE_CHAR        (256)       // \[X̂Ps̍ő啶
#define     MAX_SOURCE_LINE             (20000)     // \[X̍ős
#define     MAX_SOURCE_FILE             (256)       // RpCΏۃ\[Xyт̃\[XɃCN[hĂt@C̍v̍ő
#define     MAX_SOURCE_FILE_NAME_CHAR   (256)       // RpCΏۃ\[Xyт̃\[XɃCN[hĂt@CivpXj̕

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ͊֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#define     MAX_IDENTIFIER_CHAR         (32)        // ʎq̍ő啶@̏ꍇ31OK̂͂
#define     MAX_NUMERIC_LITERAL_CHAR    (16)        // le̍ő啶@̏ꍇ16OK̂͂
#define     MAX_STRING_LITERAL_CHAR     (1023)      // 񃊃e̍ő啶@̏ꍇ1023OK̂͂
#define     TOKEN_RATE                  (100)       // \[XPs̕σg[Ni͌ʊi[̈TCYɎgj
#define     MAX_IDENTIFIER_TABLE        (10000)     // ʎqe[u̍ővf@ꂾ΁BBB
#define     MAX_STRING_LITERAL_TABLE    (10000)     // 񃊃ee[u̍ővf
#define     MAX_NUMERIC_LITERAL_TABLE   (10000)     // lee[u̍ővf

//=== g[N.ϐ̑ ===
#define     TOKEN_VOLATILE          (100)       // \ volatile
#define     TOKEN_REGISTER          (101)       // \ register
#define     TOKEN_CONST             (102)       // \ const
#define     TOKEN_AUTO              (103)       // \ auto
#define     TOKEN_STATIC            (104)       // \ static
#define     TOKEN_EXTERN            (105)       // \ extern
#define     TOKEN_SIGNED            (106)       // \ signed
#define     TOKEN_UNSIGNED          (107)       // \ unsigned

//=== g[N.ϐ̌^ ===
#define     TOKEN_VOID              (108)       // \ void
#define     TOKEN_CHAR              (109)       // \ char
#define     TOKEN_SHORT             (110)       // \ short
#define     TOKEN_INT               (111)       // \ int
#define     TOKEN_LONG              (112)       // \ long
#define     TOKEN_FLOAT             (113)       // \ float
#define     TOKEN_DOUBLE            (114)       // \ double
#define     TOKEN_ENUM              (115)       // \ enum

//=== g[N.f[^\`ׂ̂ ===
#define     TOKEN_STRUCT            (116)       // \ struct
#define     TOKEN_UNION             (117)       // \ union
#define     TOKEN_TYPEDEF           (118)       // \ typedef

//=== g[N.t[ ===
#define     TOKEN_IF                (119)       // \ if
#define     TOKEN_ELSE              (120)       // \ else
#define     TOKEN_BREAK             (121)       // \ break
#define     TOKEN_CASE              (122)       // \ case
#define     TOKEN_CONTINUE          (123)       // \ continue
#define     TOKEN_DO                (124)       // \ do
#define     TOKEN_FOR               (125)       // \ for
#define     TOKEN_SWITCH            (126)       // \ switch
#define     TOKEN_GOTO              (127)       // \ goto
#define     TOKEN_RETURN            (128)       // \ return
#define     TOKEN_WHILE             (129)       // \ while
#define     TOKEN_DEFAULT           (130)       // \ default

//=== g[N.Zq͋؂蕶 ===
#define     TOKEN_SIZEOF            (131)       // \ sizeof
#define     TOKEN_SQUARE_L          (132)       // [
#define     TOKEN_SQUARE_R          (133)       // ]
#define     TOKEN_BRACE_L           (134)       // {
#define     TOKEN_BRACE_R           (135)       // }
#define     TOKEN_BRACKET_L         (136)       // (
#define     TOKEN_BRACKET_R         (137)       // )
#define     TOKEN_COLON             (138)       // :
#define     TOKEN_SEMICOLON         (139)       // ;
#define     TOKEN_COMMA             (140)       // ,
#define     TOKEN_PERIOD            (141)       // .
#define     TOKEN_ARROW             (142)       // ->

#define     TOKEN_NOT               (143)       // ~  P
#define     TOKEN_DOUBLE_PLUS       (144)       // ++ P
#define     TOKEN_DOUBLE_MINUS      (145)       // -- P

#define     TOKEN_PLUS              (146)       // + P
#define     TOKEN_MINUS             (147)       // - P
#define     TOKEN_ASTERISK          (148)       // * P
#define     TOKEN_DIV               (149)       // /
#define     TOKEN_MOD               (150)       // %
#define     TOKEN_AMPERSAND         (151)       // & P
#define     TOKEN_OR                (152)       // |
#define     TOKEN_XOR               (153)       // ^
#define     TOKEN_SHIFT_L           (154)       // <<
#define     TOKEN_SHIFT_R           (155)       // >>

#define     TOKEN_LESS              (156)       // <
#define     TOKEN_GRATER            (157)       // >
#define     TOKEN_LESS_EQ           (158)       // <=
#define     TOKEN_GRATER_EQ         (159)       // >=
#define     TOKEN_EQ_EQ             (160)       // ==
#define     TOKEN_NOT_EQ            (161)       // !=

#define     TOKEN_EXCLAMATION       (162)       // ! P
#define     TOKEN_AND_AND           (163)       // &&
#define     TOKEN_OR_OR             (164)       // ||

#define     TOKEN_EQ                (165)       // =
#define     TOKEN_PLUS_EQ           (166)       // +=
#define     TOKEN_MINUS_EQ          (167)       // -=
#define     TOKEN_MULT_EQ           (168)       // *=
#define     TOKEN_DIV_EQ            (169)       // /=
#define     TOKEN_MOD_EQ            (170)       // %=
#define     TOKEN_AND_EQ            (171)       // &=
#define     TOKEN_XOR_EQ            (172)       // ^=
#define     TOKEN_OR_EQ             (173)       // |=
#define     TOKEN_SHIFT_L_EQ        (174)       // <<=
#define     TOKEN_SHIFT_R_EQ        (175)       // >>=

#define     TOKEN_QUESTION          (176)       // ?
#define     TOKEN_ELLIPSIS          (177)       // ...


//=== g[N.ʎq ===
#define     TOKEN_IDENTIFIER        (178)       // ʎq

//=== g[N.e ===
#define     TOKEN_STRING_LITERAL    (179)       // 񃊃e
#define     TOKEN_NUMERIC_LITERAL   (180)       // le

//=== leǂȕ\ŋLqĂH ===
#define     DESCRIPTION_HEX         (0)         // 16iŋLqĂ
#define     DESCRIPTION_DEC         (1)         // 10iŋLqĂ
#define     DESCRIPTION_REAL        (2)         // ŋLqĂ

//=== le̓[h ===
#define     NUMLITERAL_DEC_MODE     (0)
#define     NUMLITERAL_HEX_READY    (1)
#define     NUMLITERAL_HEX_MODE     (2)

//=== l(萔)e̓[h ===
#define     NUMSTRLITERAL_NOMAL     (0)
#define     NUMSTRLITERAL_ESCAPE    (1)

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// \/Ӗ͊֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#define     MAX_ARRAY_DIM           (16)  //z̍ő原@16΁EEE
#define     NO_ARRAY_SIZE           (-1)
#define     MAX_ARG_NUM             (64)  //̍ő(Ƃ肠)

#define     SCOPE_EX                (0)
#define     SCOPE_GL                (1)
#define     SCOPE_PV                (2)
#define     SCOPE_ATS               (3)
#define     SCOPE_AT                (4)
#define     SCOPE_ARG               (5)

#define     SCOPE_STRACT_DECL_GL    (100)  // globalȍ\̂̌^`
#define     SCOPE_STRACT_DECL_PV    (101)  // ֐̊Ostatic錾ꂽ\̂̌^`
#define     SCOPE_STRACT_DECL_AT    (102)  // ֐̒Ő錾ꂽ\̂̌^`

#define     SIGN                    (1)
#define     UNSIGN                  (0)

#define     NOT_POINTER             (0)

#define     TYPE_VOID               (0)
#define     TYPE_CHAR               (1)
#define     TYPE_SHORT              (2)
#define     TYPE_INT                (3)
#define     TYPE_LONG               (4)
#define     TYPE_FLOAT              (5)
#define     TYPE_DOUBLE             (6)
#define     TYPE_ENUM               (7)
#define     TYPE_STRUCT             (8)
#define     TYPE_UNION              (9)
#define     TYPE_TYPEDEF            (10)
#define     TYPE_NOTYPE             (127)

#define     TYPE_NOT_FUNCTION_POINTER   (0)
#define     TYPE_FUNCTION_POINTER       (1)

#define     SIZEOF_VOID             (0)
#define     SIZEOF_CHAR             (1)
#define     SIZEOF_SHORT            (2)
#define     SIZEOF_INT              (4)
#define     SIZEOF_LONG             (4)
#define     SIZEOF_FLOAT            (4)
#define     SIZEOF_DOUBLE           (8)
#define     SIZEOF_ENUM             (4)
#define     SIZEOF_POINTER          (4)

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// ԃR[h֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
#define     USE_GP
//@̃IvVLɂƃO[oϐ̃AhXvZ
//@x[XAhXƂāAGP(R10)gp
//@bgF  s̃O[oϐAhX̃x[XAhXsɔCӂɎwł
//              eCPURAɃO[oϐAhX̃x[XAhXw肷鎖\
//@fbgF̃IvV̏ꍇƔׂăO[oϐ̃AhXvZPXebv]vɂ
//              ėpɎgpł郌WX^P
//̃IvV̏ꍇ̓́AL̋t

#define     MAX_NUM_OF_VERTUAL_REG          (1024)  // zWX^gpMAX
#define     FIRST_REAL_REG_NO               (1)     // gp\ȎWX^Noŏl
#define     MAX_NUM_OF_REAL_REG             (10)    // gp\ȎWX^Noől

// ϐ̃WX^ւ̔zu
#define     VAR_ON_REG_ENABLE

// PʍœK
#define     OPTIMAIZE_EXPR_ENABLE

// œK
#define     OPTIMAIZE_BRANCH_ENABLE

// ֐Ăяo32rbgl̃[hPC΃[hgpMOVH_IOR_Ȋgݍ킹g
#define       NO_USE_PC_OFFSET_LD

// _Zʂ1/0̐ݒMOVL_Igi_Zʂ̐ݒA̍œKŔ肷ׁj
#define       USE_MOVLI_FOR_LOGICAL_RESULT

// ֐̕ԂlgĂȂ΁A֐R[̕ԂlRs[MOVR폜
#define       REMOVE_NO_USED_RETURN


// [t֐ŁAXNb`WX^ɗ]Tꍇ́AȂׂXNb`WX^ɕϐ
// 蓖Ă悤ɍœK
#define       LEAF_FUNCTION_OPTIMAIZE


#ifdef VAR_ON_REG_ENABLE
    #define     NUM_OF_VER_ON_REG            (4)    // WX^֔zu\ȕϐ̐
    #define     NUM_OF_TMP_REG               (0)
    #define     ARG_DELIVERY_METHOD1
    #define     NO_ESCAPE_SCRATCH_REG               // Ă΂ꂽ֐ŃXNb`WX^ޔȂB
#else 
    #define     NUM_OF_VER_ON_REG            (0)    // WX^֔zu\ȕϐ̐
    #define     NUM_OF_TMP_REG               (3)
    #define     ARG_DELIVERY_METHOD0
    #undef      LEAF_FUNCTION_OPTIMAIZE
#endif

#ifdef USE_GP
    #define     NUM_OF_SCRATCH_REG       (MAX_NUM_OF_REAL_REG - NUM_OF_VER_ON_REG - FIRST_REAL_REG_NO)   //XNb`WX^gpMAX
#else
    #define     NUM_OF_SCRATCH_REG       (MAX_NUM_OF_REAL_REG - NUM_OF_VER_ON_REG)   //XNb`WX^gpMAX
    //#define       NOUSE_REG_OFFSET_LDST    // LD/ST, R*, R*, R* `̖ߎgpsłǂ̒x\邩v
#endif


#define     STRUCT_COPY_NO_LOOP_LIMIT       (64/4)    //\̃Rs[̃R[hAׂɓWJ邩A[v񂷂臒li128oCgȂ烋[vj


//=== R[h ===
#define     COND_ALWAYS                     (0)
#define     COND_ZERO                       (1)
#define     COND_NOT_ZERO                   (2)
#define     COND_UNSIGNED_HIGHER_OR_SAME    (3)
#define     COND_UNSIGNED_LOWER             (4)
#define     COND_MINUS                      (5)
#define     COND_PLUS                       (6)
#define     COND_OVERFLOW                   (7)
#define     COND_NOT_OVERFLOW               (8)
#define     COND_UNSIGNED_HIGHER            (9)
#define     COND_UNSIGNED_LOWER_OR_SAME     (10)
#define     COND_SIGNED_GRATER_THAN_OR_EQ   (11)
#define     COND_SIGNED_LESS_THAN           (12)
#define     COND_SIGNED_GRATER_THAN         (13)
#define     COND_SIGNED_LESS_THAN_OR_EQ     (14)

//=== ߎʃR[h ===
#define     OPECODE_TYPE_JP     (0) // 
#define     OPECODE_TYPE_LD     (1) // [h
#define     OPECODE_TYPE_ST     (2) // XgA
#define     OPECODE_TYPE_OP     (3) // Z
#define     OPECODE_TYPE_OTHER  (4) // ̑
#define     OPECODE_TYPE_DUMMY  (5) // ^

//=== ߃R[h ===
#define     OPECODE_JP_R        ( 0)    // if(Cond) PC < PC + RA
#define     OPECODE_JP_I        ( 1)    // if(Cond) PC < PC + (g)Imm24<<2
#define     OPECODE_CALL_R      ( 2)    // if(Cond) { PC <= PC + RA;    LR <= PC + 4 }
#define     OPECODE_CALL_I      ( 3)    // if(Cond) { PC <= PC + (g)Imm24<<2  LR <= PC + 4 }
#define     OPECODE_DJP_R       ( 4)    // if(Cond) PC <= RA
#define     OPECODE_RTI_R       ( 5)    // if(Cond) {PC <= ILR, SR <= ISR}

#define     OPECODE_LDW_R       (10)    // RA <= mem32(RB+RC)
#define     OPECODE_LDW_I       (11)    // RA <= mem32(RB+(g)Imm16)
#define     OPECODE_LDW_UB_R    (12)    // RA <= mem32(RB+RC);            RB <= RB+RC
#define     OPECODE_LDW_UB_I    (13)    // RA <= mem32(RB+(g)Imm16); RB <= RB+(g)Imm16
#define     OPECODE_LDW_UA_R    (14)    // RA <= mem32(RB);               RB <= RB+RC
#define     OPECODE_LDW_UA_I    (15)    // RA <= mem32(RB);               RB <= RB+(g)Imm16
//#define     OPECODE_POP         (16)   // = LDWUA, RA, SP, 4

#define     OPECODE_LDH_R       (17)    // RA <= mem16(RB+RC)
#define     OPECODE_LDH_I       (18)    // RA <= mem16(RB+(g)Imm16)
#define     OPECODE_LDH_UB_R    (19)    // RA <= mem16(RB+RC);            RB <= RB+RC
#define     OPECODE_LDH_UB_I    (20)    // RA <= mem16(RB+(g)Imm16); RB <= RB+(g)Imm16
#define     OPECODE_LDH_UA_R    (21)    // RA <= mem16(RB);               RB <= RB+RC
#define     OPECODE_LDH_UA_I    (22)    // RA <= mem16(RB);               RB <= RB+(g)Imm16

#define     OPECODE_LDB_R       (23)    // RA <= mem8(RB+RC)
#define     OPECODE_LDB_I       (24)    // RA <= mem8(RB+(g)Imm16)
#define     OPECODE_LDB_UB_R    (25)    // RA <= mem8(RB+RC);            RB <= RB+RC
#define     OPECODE_LDB_UB_I    (26)    // RA <= mem8(RB+(g)Imm16); RB <= RB+(g)Imm16
#define     OPECODE_LDB_UA_R    (27)    // RA <= mem8(RB);               RB <= RB+RC
#define     OPECODE_LDB_UA_I    (28)    // RA <= mem8(RB);               RB <= RB+(g)Imm16

#define     OPECODE_LDSH_R      (29)    // RA <= (g)mem16(RB+RC)
#define     OPECODE_LDSH_I      (30)    // RA <= (g)mem16(RB+(g)Imm16)
#define     OPECODE_LDSH_UB_R   (31)    // RA <= (g)mem16(RB+RC);            RB <= RB+RC
#define     OPECODE_LDSH_UB_I   (32)    // RA <= (g)mem16(RB+(g)Imm16); RB <= RB+(g)Imm16
#define     OPECODE_LDSH_UA_R   (33)    // RA <= (g)mem16(RB);               RB <= RB+RC
#define     OPECODE_LDSH_UA_I   (34)    // RA <= (g)mem16(RB);               RB <= RB+(g)Imm16

#define     OPECODE_LDSB_R      (35)    // RA <= (g)mem8(RB+RC)
#define     OPECODE_LDSB_I      (36)    // RA <= (g)mem8(RB+(g)Imm16)
#define     OPECODE_LDSB_UB_R   (37)    // RA <= (g)mem8(RB+RC);            RB <= RB+RC
#define     OPECODE_LDSB_UB_I   (38)    // RA <= (g)mem8(RB+(g)Imm16); RB <= RB+(g)Imm16
#define     OPECODE_LDSB_UA_R   (39)    // RA <= (g)mem8(RB);               RB <= RB+RC
#define     OPECODE_LDSB_UA_I   (40)    // RA <= (g)mem8(RB);               RB <= RB+(g)Imm16

#define     OPECODE_STW_R       (50)    // mem32(RB+RC) <= RA
#define     OPECODE_STW_I       (51)    // mem32(RB+(g)Imm16) <= RA
#define     OPECODE_STW_UB_R    (52)    // mem32(RB+RC) <= RA;                   RB <= RB+RC
#define     OPECODE_STW_UB_I    (53)    // mem32(RB+(g)Imm16) <= RA         RB <= RB+(g)Imm16
#define     OPECODE_STW_UA_R    (54)    // mem32(RB) <= RA;                      RB <= RB+RC
#define     OPECODE_STW_UA_I    (55)    // mem32(RB) <= RA                       RB <= RB+(g)Imm16
//#define     OPECODE_PUSH        (56)    // = STWUB, RA, SP, -4

#define     OPECODE_STH_R       (57)    // mem16(RB+RC) <= RA
#define     OPECODE_STH_I       (58)    // mem16(RB+(g)Imm16) <= RA
#define     OPECODE_STH_UB_R    (59)    // mem16(RB+RC) <= RA;                   RB <= RB+RC
#define     OPECODE_STH_UB_I    (60)    // mem16(RB+(g)Imm16) <= RA         RB <= RB+(g)Imm16
#define     OPECODE_STH_UA_R    (61)    // mem16(RB) <= RA;                      RB <= RB+RC
#define     OPECODE_STH_UA_I    (62)    // mem16(RB) <= RA                       RB <= RB+(g)Imm16

#define     OPECODE_STB_R       (63)    // mem8(RB+RC) <= RA
#define     OPECODE_STB_I       (64)    // mem8(RB+(g)Imm16) <= RA
#define     OPECODE_STB_UB_R    (65)    // mem8(RB+RC) <= RA;                    RB <= RB+RC
#define     OPECODE_STB_UB_I    (66)    // mem8(RB+(g)Imm16) <= RA          RB <= RB+(g)Imm16
#define     OPECODE_STB_UA_R    (67)    // mem8(RB) <= RA;                       RB <= RB+RC
#define     OPECODE_STB_UA_I    (68)    // mem8(RB) <= RA                        RB <= RB+(g)Imm16


#define     OPECODE_MOV_I       (80)    // RA <= (g)Imm
#define     OPECODE_MOV_R       (81)    // RA <= RC
#define     OPECODE_MOVL_I      (82)    // RA <= {16'h0, Imm}
#define     OPECODE_MOVH_I      (83)    // RA <= {Imm, 16'h0}
#define     OPECODE_ADD_R       (84)    // RA <= RB + RC
#define     OPECODE_ADD_I       (85)    // RA <= RB + (g)Imm
#define     OPECODE_SUB_R       (86)    // RA <= RB - RC
#define     OPECODE_SUB_I       (87)    // RA <= RB - (g)Imm
#define     OPECODE_AND_R       (88)    // RA <= RB & RC
#define     OPECODE_AND_I       (89)    // RA <= RA & {16'h0, Imm}
#define     OPECODE_OR_R        (90)    // RA <= RB | RC
#define     OPECODE_OR_I        (91)    // RA <= RA | {16'h0, Imm}
#define     OPECODE_XOR_R       (92)    // RA <= RB ^ RC
#define     OPECODE_XOR_I       (93)    // RA <= RA ^ {16'h0, Imm}
#define     OPECODE_LSR_R       (94)    // RA <= RB >> RC[4:0]
#define     OPECODE_LSR_I       (95)    // RA <= RB >> Imm[4:0]
#define     OPECODE_LSL_R       (96)    // RA <= RB << RC[4:0]
#define     OPECODE_LSL_I       (97)    // RA <= RB << Imm[4:0]
#define     OPECODE_ASR_R       (98)    // RA <= RB >>> RC[4:0]
#define     OPECODE_ASR_I       (99)    // RA <= RB >>> Imm[4:0]
#define     OPECODE_MUL_R       (100)   // RA <= RB[31:0] * RC[31:0]
#define     OPECODE_MUL_I       (101)   // RA <= RB[31:0] * (g)Imm[15:0]
#define     OPECODE_DIVU_R      (102)   // RA <= RB[31:0] / RC[31:0]
#define     OPECODE_DIVU_I      (103)   // RA <= RB[31:0] / (g)Imm[15:0]
#define     OPECODE_DIV_R       (104)   // RA <= RB[31:0] / RC[31:0]
#define     OPECODE_DIV_I       (105)   // RA <= RB[31:0] / (g)Imm[15:0]
#define     OPECODE_MODU_R      (106)   // RA <= RB[31:0] / RC[31:0]
#define     OPECODE_MODU_I      (107)   // RA <= RB[31:0] / (g)Imm[15:0]
#define     OPECODE_MOD_R       (108)   // RA <= RB[31:0] / RC[31:0]
#define     OPECODE_MOD_I       (109)   // RA <= RB[31:0] / (g)Imm[15:0]

#define     OPECODE_NOP         (120)   // NOP

#define     OPECODE_IMMSET      (200)   // ^AZu߁ilߍ݁j
#define     OPECODE_ESCAPE_REGS (201)   // $EscapeRegs$
#define     OPECODE_RETURN_REGS (202)   // $ReturnRegs$


//=== Iyh^Cv ===
#define     OPERAND_TYPE_NOTHING                ( 0) //IyhȂ
#define     OPERAND_TYPE_SPR                    ( 1) //ʂȃWX^ GP, FP, SP, LR, PC, NON
#define     OPERAND_TYPE_GPR                    ( 2) //ėpWX^
#define     OPERAND_TYPE_SHORT_IMM              ( 3) //16rbgȉ̑l
#define     OPERAND_TYPE_LONG_IMM               ( 4) //32rbgl
#define     OPERAND_TYPE_CONDITION              ( 5) //R[h
#define     OPERAND_TYPE_LABEL                  ( 6) //x
#define     OPERAND_TYPE_LABEL_ADR_HI           ( 7) //x΃AhX16bit
#define     OPERAND_TYPE_LABEL_ADR_LO           ( 8) //x΃AhX16bit
#define     OPERAND_TYPE_VARIABLE               ( 9) //ϐ
#define     OPERAND_TYPE_VARIABLE_HI            (10) //ϐ
#define     OPERAND_TYPE_VARIABLE_LO            (11) //ϐ
#define     OPERAND_TYPE_FUNCTION               (12) //֐AhX
#define     OPERAND_TYPE_PC_OFFSET_OFFUNCTION   (13) //֐AhX
#define     OPERAND_TYPE_FUNCTION_HI            (14) //֐AhX16bit
#define     OPERAND_TYPE_FUNCTION_LO            (15) //֐AhX16bit
#define     OPERAND_TYPE_SIZEOF_LOCALS          (16) // $SizeOfLocals$
#define     OPERAND_TYPE_SIZEOF_GLOBALS         (17) // $SizeOfGlobals$
#define     OPERAND_TYPE_SIZEOF_ARGS            (18) // $SizeOfGlobals$

//=== SpesialPurposeRegister ===
#define     SPR_GP                  (10)
#define     SPR_FP                  (11)
#define     SPR_SP                  (12)
#define     SPR_LR                  (13)
#define     SPR_PC                  (15)
#define     SPR_NON                 (15)


//=== vOx̓ʂȃP[X===
#define     PLABEL_FUNC_ENTRY       (0)
#define     PLABEL_FUNC_EXIT        (1)
#define     PLABEL_NON              (-1)


//=== ex^Cv ===
#define     LLABEL_VARIABLE           (1)
#define     LLABEL_FUNCTION           (2)
#define     LLABEL_NUMERIC_LITERAL    (3)
#define     LLABEL_STRING_LITERAL     (4)

//=== [ṽlXg[ ===================
#define     MAX_LOOP_NEST            (256)

//=== switch̃xő吔 ===================
#define     MAX_SWITCH_LABEL         (1024)

//======= [hnߐp萔 ===================
#define     SIZE_1                  (1)
#define     SIZE_2                  (2)
#define     SIZE_4                  (4)
#define     DST_IS_GPR              (OPERAND_TYPE_GPR)
#define     DST_IS_SPR              (OPERAND_TYPE_SPR)
#define     SRC_IS_GPR              (OPERAND_TYPE_GPR)
#define     SRC_IS_SPR              (OPERAND_TYPE_SPR)
#define     BASE_IS_GPR             (OPERAND_TYPE_GPR)
#define     BASE_IS_SPR             (OPERAND_TYPE_SPR)
#define     OFFSET_IS_SPR           (OPERAND_TYPE_SPR)
#define     OFFSET_IS_GPR           (OPERAND_TYPE_GPR)
#define     OFFSET_IS_IMM           (OPERAND_TYPE_SHORT_IMM)
#define     OFFSET_IS_VAR           (OPERAND_TYPE_VARIABLE)
#define     OFFSET_IS_LABEL         (OPERAND_TYPE_LABEL)
#define     BASE_UPDATE_NO          (0)
#define     BASE_UPDATE_BEFORE      (1)
#define     BASE_UPDATE_AFTER       (2)

//======= Znߐp萔 ===================
#define     RET_IS_GPR              (OPERAND_TYPE_GPR)
#define     RET_IS_SPR              (OPERAND_TYPE_SPR)
#define     ARG_IS_NOTING           (OPERAND_TYPE_NOTHING)
#define     ARG_IS_GPR              (OPERAND_TYPE_GPR)
#define     ARG_IS_SPR              (OPERAND_TYPE_SPR)
#define     ARG_IS_IMM              (OPERAND_TYPE_SHORT_IMM)
#define     ARG_IS_VAR              (OPERAND_TYPE_VARIABLE)
#define     ARG_IS_SIZEOF_LOCALS    (OPERAND_TYPE_SIZEOF_LOCALS)
#define     ARG_IS_SIZEOF_GLOBALS   (OPERAND_TYPE_SIZEOF_GLOBALS)
#define     ARG_IS_SIZEOF_ARGS      (OPERAND_TYPE_SIZEOF_ARGS)

//======= ԃR[h̃IvV ===================
#define     NOT_USE_NEW_REG     (0)
#define     USE_NEW_REG         (1)

//======= ̍œK̃IvV ===================
#define     KEEP_RESULT         (0)
#define     NOT_KEEP_RESULT     (1)

//======= [t֐ۂ ===================
#define     NOT_LEAF_FUNC       (0)
#define     LEAF_FUNC           (1)

//======= or[JϐgpĂ邩ۂ ===================
#define     NO_USE_LOCAL_AND_ARG    (1)
#define     USE_LOCAL_AND_ARG       (0)

//=====================================================================================================
//  TYPEDEF
//=====================================================================================================
//============================================================
//===== vvZbT֘A ===================================
//============================================================
//=== vvZbTς݃\[XR[hi[e[u\vf

struct cc0_source_data_tag{
    int     SourceFileNo;                       // source_name_table̎QƗpBSourceCode[]ǂ̃\[Xt@CɊ܂܂Ăm邽
    int     SourceLineNo;                       // SourceCode[]source_name_table[SourceFileNo].SourceNamẻsڂ
    char    SourceCode[MAX_SOURCE_LINE_CHAR];   // \[XR[hivvZbTς݁j
};
typedef struct cc0_source_data_tag cc0_source_data;

//=== \[Xt@C̃e[uiCN[h܂ށj\vf
struct cc0_source_file_tag{
    char    FileName[MAX_SOURCE_FILE_NAME_CHAR];
};
typedef struct cc0_source_file_tag cc0_source_file;

//=== vvZbTʊi[p\
struct cc0_result_tag{
    cc0_source_data     *SrcTbl;        //vvZbTς݃\[XR[hi[e[uւ̃|C^
    int                 NumOfSrcLine;   //L̗vf
    cc0_source_file     *SrcFileTbl;    //\[Xt@C̃e[uiCN[h܂ށjւ̃|C^
    int                 NumOfSrcFile;   //L̗vf
} ;
typedef struct cc0_result_tag cc0_result;

//=== vvZbTo̓f[^ANZX邽߂̃nh
struct cc0_result_handle_tag{
    int     SrcTblIndex;    // cc0_result.SrcTblIndex
    int     CodeIndex;      // cc0_result.SrcTbl[SrcTblIndex].SourceCodeIndex
} ;
typedef struct cc0_result_handle_tag cc0_result_handle;


//============================================================
//===== ͊֘A =========================================
//============================================================
//=== ͂Ő؂og[Ni[ׂ̃e[u\vf
struct cc1_token_tag{
    int     Type;           // g[N
    int     SrcTblIndex;    // g[Ncc0_result.SrcTbl̂ǂoꂽ
    int     ExtInfoIndex;   // ʂAʎqA񃊃eAlêꂩłꍇɁAꂼ
                            // i[e[uANZXׂIndex
                            // ʎq           cc1_identifier
                            // 񃊃e   cc1_string_literal
                            // le     cc1_numeric_literal
} ;
typedef struct cc1_token_tag cc1_token;

//=== ʎqe[u\vf
struct cc1_identifier_tag{
    char    Identifier[MAX_IDENTIFIER_CHAR];
};
typedef struct cc1_identifier_tag cc1_identifier;

//=== 񃊃ee[u\vf
struct cc1_string_literal_tag{
    char    *StringLiteral;
} ;
typedef struct cc1_string_literal_tag cc1_string_literal;

//=== le̒l
union cc1_numeric_tag{
    unsigned long   FixedPointValue;
    double          FloatingPointValue;
} ;
typedef union cc1_numeric_tag cc1_numeric;

//=== lee[u\vf
struct cc1_numeric_literal_tag{
    int             Type;   // ̌^Ɣ͈̓`FbNɎgH
                            // DESCRIPTION_HEX  16iŋLqĂ
                            // DESCRIPTION_DEC  10iŋLqĂ
                            // DESCRIPTION_REAL ŋLqĂ
    cc1_numeric     Value;  // l
} ;
typedef struct cc1_numeric_literal_tag cc1_numeric_literal;

//=== ͌ʊi[p\
struct cc1_result_tag{
    int                 MaxTokenNum;  // őg[N(TOKEN_RATE~\[X(include܂)s)
    int                 TokenTblIndex;// TokenTblANZXpIndexicc1s͑g[Nj
    int                 IdentifierNum;// IdentifierTbl֓o^ς݂̎ʎq̐
    int                 StrLiteralNum;// StrLiteralTbl֓o^ς݂̎ʎq̐
    int                 NumLiteralNum;// NumLiteralTbl֓o^ς݂̎ʎq̐
    cc1_token           *TokenTbl;
    cc1_identifier      *IdentifierTbl;
    cc1_string_literal  *StrLiteralTbl;
    cc1_numeric_literal *NumLiteralTbl;
} ;
typedef struct cc1_result_tag cc1_result;

//============================================================
//===== \͊֘A =========================================
//============================================================
//=== \(p)^̗vf
struct struct_info_tag{
    struct struct_info_tag  *Prev;      // Prev link
    struct struct_info_tag  *Next;      // Next link
    char                    *TagName;   // ^O
    char                    *FuncName;  // [JŐ錾ꂽꍇ̊֐
    char                    Provisional;// o^tO 0o^
    char                    Scope;      // 0:external, 1:global, 2:private, 3:static auto, 4:auto
    char                    Type;       // 8:struct, 9:union
    int                     StructSize;       // \̂̃TCYipfBO܂ށj
    struct variable_info_tag  *Member;    // \̃oւ̃N
};
typedef struct struct_info_tag struct_info;

//=== z̊e̗vf
struct dimension_info_tag{
    int     NumOfElements[MAX_ARRAY_DIM];
    int     ElementSize[MAX_ARRAY_DIM];
} ;
typedef struct dimension_info_tag dimension_info;


//=== ϐ̗vfTCỸXg(lǍ݂Ŏgp)
struct element_init_val_info_tag{
    struct element_init_val_info_tag *Next;
    char                             Sign;
    char                             Pointer;
    char                             Id;     //0ȊȌꍇA*Str͎ʎqA0̎́A񃊃e
    int                              Size;
    int                              Offset;
    unsigned long                    Value;  // lil̏ꍇjStrNULL̏ꍇ́A炪L
    char                             *Str;   // lȉꍇj
    dimension_info                   *DimInfo;// z\vf
};
typedef struct element_init_val_info_tag element_init_val_info;

//=== ϐ̗vfTCỸXg̃wb_(lǍ݂Ŏgp)
struct element_initial_list_header_tag{
    int                         InfoNum;
    element_init_val_info       *Entry;
    element_init_val_info       *Last;
} ;
typedef struct element_initial_list_header_tag element_initial_list_header;

#define         REG_DIS     (0) //WX^zus\
#define         REG_ENA     (1) //WX^zu\
struct opti_info_t{
    char            RegEna;         // REG_DIS/REG_ENA
    char            RegNo;          // 蓖Ă郌WX^NoF1`NUM_OF_SCRATCH_REGL
    unsigned long   RefCount;       // QƉ񐔃JE^
};
typedef struct opti_info_t opti_info;

//=== ϐ\̗vf
struct variable_info_tag{
    struct variable_info_tag    *Prev;      // Prev link
    struct variable_info_tag    *Next;      // Next link
    char                        *Name;      // O
    char                        *FuncName;  // [JŐ錾ꂽꍇ̊֐
    char                        Scope;      // 0:external, 1:global, 2:private, 3:static auto, 4:auto
    char                        Sign;       // 0:unsigned 1:signed
    char                        Pointer;    // 0:not pointer 1:pointer, 2:pointer of pointer, ...
    char                        Type;       // 0:void, 1:char, 2:short, 3:int, 4:long, 5:float, 6:double, 7:enum, 8:struct, 9:union
    char                        TypeFunction;// 0:֐|C^ł͂Ȃ 1:֐|C^
    char                        ArrayDim;   // 0:not array, 1:array(1), 2:array(1)...
    char                        FuncPointer;// 0:not function pointer 1:function pointer
    char                        ArgNum;     // ̐(FuncPointer0ȊȌꍇL)
    int                         TypeSize;   // ^̃TCY
    int                         TotalSize;  // ϐizȂ΁ȂŚj̃TCY
    int                         Offset;     // \̂̃oȂ΁A\̐擪̃ItZbg@[JϐȂ
    struct variable_info_tag    *ArgList;   // ֐|C^̏ꍇ́AɈi[(FuncPointer0ȊȌꍇL)
    dimension_info              *DimInfo;   // z\vf
    struct_info                 *StructInfo;// \̌^ւ̃|C^(\̂ł΁j
    element_initial_list_header InitValHead;// Initial value
    opti_info                   OptiInfo;   // œKp
};
typedef struct variable_info_tag variable;

//=== TypedefΉ\
struct typedef_info_tag{
    struct typedef_info_tag *Prev;      // Prev link
    struct typedef_info_tag *Next;      // Next link
    char                    *TypeName;  // ^O
    char                    Sign;       // 0:unsigned 1:signed
    char                    Pointer;    // 0:not pointer 1:pointer, 2:pointer of pointer, ...
    char                    Type;       // 0:void, 1:char, 2:short, 3:int, 4:long, 5:float, 6:double, 7:enum, 8:struct, 9:union
    char                    TypeFunction;// 0:֐|C^ł͂Ȃ 1:֐|C^
    char                    FuncPointer;// 0:not function pointer 1:function pointer
    char                    ArgNum;     // ̐(FuncPointer0ȊȌꍇL)
    struct variable_info_tag  *ArgList;   // ֐|C^̏ꍇ́AɈi[(FuncPointer0ȊȌꍇL)
    struct_info             *StructInfo;// \̌^ւ̃|C^(\̂ł΁j
} ;
typedef struct typedef_info_tag typedef_info;

//================================== ԃR[h֘A =============================================
#define         STATEMENT_START      ('S')
#define         STATEMENT_END        ('E')
//=== œK̃qgƂȂ(Ƃ肠qgɂȂ肻Ȃ̂𖄂ߍł)
#define         EXPRESSION_OUTSIDE    (' ')
#define         EXPRESSION_START      ('S')
#define         EXPRESSION_INSIDE     ('|')
#define         EXPRESSION_END        ('E')
#define         EXPRESSION_RESULT     ('*')
#define         EXPRESSION_NOT_RESULT (' ')
#define         OPTIMIZE_START        ('S')
#define         OPTIMIZE_END          ('E')
#define         COPY_FOR_POSTFIX_EXPR     ('C')
#define         NOT_COPY_FOR_POSTFIX_EXPR (' ')

struct optimization_hint_tag{
    char        Position;
    char        Result;
    char        Copy;//u++/--̎ɁAZO̒lRs['C'
    short       LoopLevel;
} ;
typedef struct optimization_hint_tag optimizatio_hint;

//=== ԃR[h̃IyR[h
struct vopecode_info_tag{
    unsigned char   Type; // OPECODE_TYPE_JP/LD/ST/OP/OTHER/DUMMY
    unsigned char   Code; // OPECODE_JP_R...
} ;
typedef struct vopecode_info_tag v_opecode;

//=== ԃR[h̃Iyh̒l
union value_info_tag{
    unsigned long           Condition;  //R[h
    unsigned long           NumLiteral; //l
    int                     RegNo;      //WX^No
    int                     LabelNo;    //xNo 17bitȏ̐lAAvOxi[ꂽAhXwxNo
                                        //xNo͎t
    variable                *var;       //ϐ
    struct function_info_tag  *func;      //֐
} ;
typedef union value_info_tag value_info;

//=== ԃR[h̃Iyh
struct voperand_info_tag{
    unsigned char       Type;   // OPERAND_TYPE_NOTHING/SPR/GPR...
    value_info          ValueInfo;
    int                 VariableOffset; // Type == OPERAND_TYPE_VARIABLE ̎̂ݗLȒlB̍œK̂ݎgp
} ;
typedef struct voperand_info_tag v_operand;


//=== ԃR[h
struct vertual_code_info_tag{
    struct vertual_code_info_tag  *Prev;
    struct vertual_code_info_tag  *Next;
    int                         LabelNo;//0͊֐̓A1͊֐̏oA-1̓xȂALȊO͔Cӂ̃Wv
    int                         SrcFileIndex;//\[Xt@Ce[uIndex
    int                         SrcFileLine;//\[X̉C߂
    optimizatio_hint            OptimaizationHint;
    v_opecode                   OpCode;
    v_operand                   OpRand0;//͗vfR̔zɂƂ΂悩
    v_operand                   OpRand1;
    v_operand                   OpRand2;
};
typedef struct vertual_code_info_tag vertual_code;

//==== ԃR[hXg̓ ========
typedef struct vertual_code_list_header_tag{
    vertual_code                *Entry; //
    vertual_code                *Last;  //
} ;
typedef struct vertual_code_list_header_tag vertual_code_list_header;


//==== ̍œK֘A =====================
struct vertual_reg_list_tag{
    struct vertual_reg_list_tag   *Prev;
    struct vertual_reg_list_tag   *Next;
    int                         RegNo;
    int                         UsedTimes;//gp
    int                         Result;//P3CC_TRUE/P3CC_FALSE
};
typedef struct vertual_reg_list_tag vertual_reg_list;


//==== vOɖߍރȅ ========
typedef union literal_label_ext_info_tag{
    variable                *v;     // ^CvLLABEL_VARIABLEFvariableւ̃|C^
    struct function_info_tag  *f;     // ^CvLLABEL_FUNCTIONFfunctionւ̃|C^
    unsigned long           Num;    // ^CvLLABEL_NUMERIC_LITERALFl̂
    char                    *Str;   // ^CvLLABEL_STRING_LITERALFւ̃|C^
} ;
typedef union literal_label_ext_info_tag literal_label_ext_info;


struct literal_label_info_tag{
    struct literal_label_info_tag *Next;      // Next link
    int                         LabelNo;
    int                         Type;       // ^CvF
    literal_label_ext_info      ExtInfo;    // g
};
typedef struct literal_label_info_tag literal_label;

//==== [U[`xƃxNȏΉ\
struct user_label_info_tag{
    struct user_label_info_tag    *Next;
    int                         ReferSolvFlag;  //xQƉtO
    int                         LabelNo;        //xNo
    char                        *LabelStr;      //x
};
typedef struct user_label_info_tag user_label;

//=== [v̓ƏõxNoL^X^bN ===================
struct loop_label_stack_t{
    int                     Depth;
    int                     LoopTopLabel[MAX_LOOP_NEST];
    int                     LoopBtmLabel[MAX_LOOP_NEST];
};
typedef struct loop_label_stack_t loop_label_stack;

//==== WX^Ɋ蓖Ăϐ̃e[u  ==================================
struct reg_vs_variable_table_t{
    variable    *v[NUM_OF_SCRATCH_REG + NUM_OF_VER_ON_REG + 1];
};
typedef struct reg_vs_variable_table_t reg_vs_variable_table;

//=== ֐̏ =========================================================
struct function_info_tag{
    struct function_info_tag    *Prev;      // Prev link
    struct function_info_tag    *Next;      // Next link
    int                         SrcFileIndexOfFuncEntry;
    int                         SrcFileLineOfFuncEntry;
    char                        *FuncName;  // O
    char                        DeclaredPt; // 0Fvg^Cv` 1:`ς
    char                        DeclaredBody; // 0F֐{̖` 1:`ς
    char                        Scope;      // 0:external, 1:global, 2:private
    char                        Sign;       // 0:unsigned 1:signed
    char                        Pointer;    // 0:not pointer 1:pointer, 2:pointer of pointer, ...
    char                        Type;       // TYPE_VOID, TYPE_CHAR, ...
    char                        ArgNum;     // ̐
    int                         TypeSize;   // ^̃TCY
    int                         SizeOfLocal;//S[JϐTCY
    char                        MaxNumOfUsedVReg;//֐̍őgpWX^ێ
    char                        NumOfVarOnReg;//֐̍őgpWX^ێ
    char                        NumOfUsedScratchReg;//֐̍őgpWX^ێ
    struct_info                 *StructInfo;// \̌^ւ̃|C^(\̂ł΁j
    variable                    *ArgList;   // Xgւ̃|C^
    variable                    *VariableList; // localϐXgւ̃|C^
    user_label                  *UserLabelList;//[U[xXgւ̃|C^
    literal_label               *LiteralLabelList;//eQƂ邽߂̃xXgւ̃|C^
    vertual_code_list_header    VCodeListHeader;//ԃR[hi[
    reg_vs_variable_table       RegVsVar;   //WX^Ɋ蓖Ăϐ̃e[u
    char                        UsedRegTbl[NUM_OF_VER_ON_REG + NUM_OF_SCRATCH_REG + 1];
};
typedef struct function_info_tag function;

//=== ͊֐̕Ԃl֘A =============================================================
//Ԃ@
#define     RETURN_METHOD_REG       (0) // WX^ŕԂi^PrimInfoj
#define     RETURN_METHOD_NUMERIC   (1) // l̂́i^ȂjŕԂ

#define     RETURN_PROPERTY_ADDRESS (0) // MethodŕԂl̓AhX
#define     RETURN_PROPERTY_VALUE   (1) // MethodŕԂl͒PȒl

//Ԃl
union result_value_info_tag{
    unsigned long           RegNo;      //WX^No        FRETURN_METHOD_REG
    unsigned long           Num;        //l              FRETURN_METHOD_LITERAL
} ;
typedef union result_value_info_tag result_value_info;


//=== ͊֐̕Ԃľ^{
struct result_type_info_tag{
    char                        Sign;       // 0:unsigned 1:signed
    char                        Pointer;    // 0:not pointer 1:pointer, 2:pointer of pointer, ...
    char                        Type;       // 0:void, 1:char, 2:short, 3:int, 4:long, 5:float, 6:double, 7:enum, 8:struct, 9:union
    char                        TypeFunction;// 0:֐|C^ł͂Ȃ 1:֐|C^
    char                        FuncPointer;// 0:not function pointer 1:function pointer
    char                        ArgNum;     // ̐(FuncPointer0ȊȌꍇL)
    int                         BasicTypeSize;// ^̃TCY
    struct variable_info_tag    *ArgList;   // ֐|C^̏ꍇ́AɈi[(FuncPointer0ȊȌꍇL)
    dimension_info              *DimInfo;   // z\vf
    struct_info                 *StructInfo;
} ;
typedef struct result_type_info_tag result_type_info;

//=== ͊֐̕Ԃl
struct expression_analsys_result_tag{
    char                    Method      ;//Ԃ@
    char                    Property    ;//
    char                    CastFlag    ;// 0:LXgA0ȊOFLXg
    result_value_info       Value       ;//Ԃl
    result_type_info        TypeInfo    ;//^̏
    result_type_info        BaseTypeInfo;//LXgꂽ^̏iChastFlag0̎Lj
} ;
typedef struct expression_analsys_result_tag expression_analsys_result;



//===================================================================================================
//  ֐̃vg^Cv
//===================================================================================================
//======== vvZbT ================
int p3cc0(char *SrcFileName, cc0_result *Cc0Res);
int P3cc0ResultAreaGet(cc0_result *Cc0Res, int Line);
int P3cc0ResultAreaFree(cc0_result *Cc0Res);

//========  ================
int p3cc1(cc0_result *Cc0Res, cc1_result *Cc1Res);
int P3cc1ResultAreaGet(cc1_result *Cc1Res, int NumOfSrcLine);
int P3cc1ResultAreaFree(cc1_result *Cc1Res);

//======== \́R[hRpCʏo ================
int p3cc2(cc0_result *Cc0Res, cc1_result *Cc1Res);


//===================================================================================================
//  ʊ֐̃vg^Cv
//===================================================================================================
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 񑀍֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
int FileExtensionSwitch(char *In, char *Out, char *Ext);
int FileExtensionCut(char *In, char *Out);
int IsChar(char c, char *s);
int IsAlphaAndUnderLine(char c);
int IsAlphaAndNumAndUnderLine(char c);
int IsNum(char c);
int IsHex(char c);

//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// cc0_result(vvZbŤ)֘Ȃ
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
void Print_cc0_result(cc0_result *Cc0Res);
int GetSrcInfoFromCc0Res(cc0_result *Cc0Res, cc0_result_handle *Handle, char **SrcFile, int *LineNo, char **SrcCode);
void CopyCc0ResHndle(cc0_result_handle *d, cc0_result_handle *s);
char ForwardCc0ResHandleOneLine(cc0_result *Cc0Res, cc0_result_handle *Handle);
char GetCharFromCc0Res(cc0_result *Cc0Res, cc0_result_handle *Handle);


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// cc1_result(͂̌)֘Ȃ
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
void Print_cc1_result(cc0_result *Cc0Res, cc1_result *Cc1Res);

//===================================================================================================
//  GLOBALϐ
//===================================================================================================
extern char     SrcFileName[];
extern FILE     *MsgOut;
extern int      SmallMemory;
