//============================================================
//  TARGET SYSTEM : Psm3Core (Processor Study Model 3 Core)
//  FUNCTION      : Psm3 C Compiler (ʊ֐ЂƂ܂Ƃ)
//
//                  Copyright (C) 2009-2010 by Tomoyuki Inomoto
//=============================================================
#include    <stdio.h>
#include    <stdlib.h>
#include    <string.h>
#include    <ctype.h>

#include    "p3cc.h"


//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
// 񑀍֘A
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
//==============================================================
//= FileExtensionSwitch[t@C쐬igq̒uj]
// [@\] *In̕"."*ExtŒu*Out֊i[
// [] LQ
// [Ԓl] P3CC_OKԂB
//===============================================================
int FileExtensionSwitch(char *In, char *Out, char *Ext)
{
    while(*In != '\0'){
        *Out = *In;
        ++Out, ++In;
        if(*In == '.') break;
    }
    *Out = '.';
    ++Out;
    while(*Ext != '\0'){
        *Out = *Ext;
        ++Out, ++Ext;
    }
    *Out = '\0';
    return P3CC_OK;
}
//==============================================================
//= FileExtensionCut[t@C̊gq̍폜]
// [@\] *In̕"."O*Out֊i[
// [] LQ
// [Ԓl] P3CC_OKԂB
//===============================================================
int FileExtensionCut(char *In, char *Out)
{
    while(*In != '\0'){
        *Out = *In;
        ++Out, ++In;
        if(*In == '.') break;
    }
    *Out = '\0';
    return P3CC_OK;
}
//===============================================================
//= IsChar[csɊ܂܂镶̂ꂩƈvP3CC_OKԂ]
//===============================================================
int IsChar(char c, char *s)
{
    while(*s != '\0'){
        if(c == *s) return P3CC_OK;
        ++s;
    }
    return P3CC_NG;
}
//===============================================================
//= IsAlphaAndUnderLine[ca-zA-Z_P3CC_OKԂ]
//===============================================================
int IsAlphaAndUnderLine(char c)
{
    if(isalpha(0xFF & (int)c)) return P3CC_OK;
    return IsChar(c, "_");
}
//===============================================================
//= IsAlphaAndNumAndUnderLine[ca-zA-Z0-9_P3CC_OKԂ]
//===============================================================
int IsAlphaAndNumAndUnderLine(char c)
{
    if(isalnum(0xFF & (int)c)) return P3CC_OK;
    return IsChar(c, "_");
}
//===============================================================
//= IsNum[c0-9P3CC_OKԂ]
//===============================================================
int IsNum(char c)
{
    if(isdigit(0xFF & (int)c)) return P3CC_OK;
    return P3CC_NG;
}

//===============================================================
//= IsHex[c0-9a-fA-FP3CC_OKԂ]
//===============================================================
int IsHex(char c)
{
    if(isdigit(0xFF & (int)c)) return P3CC_OK;
    return IsChar(c, "abcdefABCDEF");
}
//===============================================================
//= str2ul[long֒u]
//===============================================================
long str2long(char *p)
{
    long    Ret;

    if(strncmp(p, "0x", 2) == 0) Ret = strtol(p,NULL,16);
    else                         Ret = strtol(p,NULL,10);
    //printf("%s, %d, %08x\n",p,radix,Ret);
    return Ret;
}
