//=======================================================================
//  TARGET PROJECT: PSM3D(Prosessor Study Model3 DualCore)
//  TARGET SYSTEM : DEMO on Sp3StarterKit (PSM3D TARGET SYSTEM)
//  FUNCTION      : vZbTPC[`
//
//                      Copyright (C) 2010 by Tomoyuki Inomoto
//=======================================================================
#include    "Psm3dSys.h"
#include    "DisplaySys.h"

//============================================================================================================
//============================================================================================================
//  EXTERN
//============================================================================================================
//============================================================================================================
void    EnaIrq(void);
void    DisIrq(void);

//============================================================================================================
//============================================================================================================
//  GLOBAL
//============================================================================================================
//============================================================================================================

//============================================================================================================
//============================================================================================================
//  PRIVATE
//============================================================================================================
//============================================================================================================

//============================================================================================================
//============================================================================================================
//  PROTOTYPE
//============================================================================================================
//============================================================================================================
//============================================================================================================
//============================================================================================================
//  BODY
//============================================================================================================
//============================================================================================================
//============================================================================================================
void P1Main(void)
//============================================================================================================
// [@\] vZbTPC[`
// [] 
// [Ԓl]

{
    unsigned short  Counter;
    int             P1TimerIrqFlag;

    //݃Rg[
    *(unsigned long *)REG_IRQ1_CREAR = 0;
    *(unsigned long *)REG_IRQ1_CREAR = 1;
    *(unsigned long *)REG_IRQ1_CREAR = 2;
    *(unsigned long *)REG_IRQ1_CREAR = 3;
    *(unsigned long *)REG_IRQ1_CREAR = 4;
    *(unsigned long *)REG_IRQ1_CREAR = 5;
    *(unsigned long *)REG_IRQ1_MASK = 0x3F;//Srbg}XN
    *(unsigned long *)REG_IRQ1_MASK &= ~BIT_IRQ_TIMER1;//^C}݂̂݋

    //^C}
    *(unsigned long *)REG_TM1_PERIOD = 10000; // 10mS
    *(unsigned long *)REG_TM1_CTRL = BIT_TM_RUN; // ^C}X^[g
    
    EnaIrq();
    
    Counter = 0;
    while(1){
        P1TimerIrqFlag = *(int *)(OCM_BASE_ADR + sizeof(int));
        if(P1TimerIrqFlag){
            *(int *)(OCM_BASE_ADR + sizeof(int)) = 0;
            ++Counter;
            if((Counter % 5) == 0){ //60mS
                DispTextLayerDraw();
            }
        }
    }
}
