﻿//=======================================================================
//  TARGET PROJECT: PSM3(Prosessor Study Model3)
//  FUNCTION      : Debugger
//
//                      Copyright (C) 2008 by Tomoyuki Inomoto
//=======================================================================
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

namespace Psm3Debugger
{
    public partial class RegBox : UserControl
    {
        public const uint P3DBG_OK = 0;
        public const uint P3DBG_NG = 1;

        public uint RegNo;
        public uint RegSetFlag;
        public uint RegSetFlag2;
        public uint RefreshFlag;

        //=　コンストラクタ =================================
        public RegBox()
        {
            InitializeComponent();
        }
        //=　共通関数[レジスタ値をGUIへ反映] =================================
        public uint RegValueSet2GUI(ref uint[] REG, ref uint[] OLD_REG, uint Flag)
        {
            int i;
            REG0.Text = String.Format("{0:X8}", REG[0]);
            if (OLD_REG[0] != REG[0]) REG0.ForeColor = Color.Blue;
            else REG0.ForeColor = Color.Black;
            REG1.Text = String.Format("{0:X8}", REG[1]);
            if (OLD_REG[1] != REG[1]) REG1.ForeColor = Color.Blue;
            else REG1.ForeColor = Color.Black;
            REG2.Text = String.Format("{0:X8}", REG[2]);
            if (OLD_REG[2] != REG[2]) REG2.ForeColor = Color.Blue;
            else REG2.ForeColor = Color.Black;
            REG3.Text = String.Format("{0:X8}", REG[3]);
            if (OLD_REG[3] != REG[3]) REG3.ForeColor = Color.Blue;
            else REG3.ForeColor = Color.Black;
            REG4.Text = String.Format("{0:X8}", REG[4]);
            if (OLD_REG[4] != REG[4]) REG4.ForeColor = Color.Blue;
            else REG4.ForeColor = Color.Black;
            REG5.Text = String.Format("{0:X8}", REG[5]);
            if (OLD_REG[5] != REG[5]) REG5.ForeColor = Color.Blue;
            else REG5.ForeColor = Color.Black;
            REG6.Text = String.Format("{0:X8}", REG[6]);
            if (OLD_REG[6] != REG[6]) REG6.ForeColor = Color.Blue;
            else REG6.ForeColor = Color.Black;
            REG7.Text = String.Format("{0:X8}", REG[7]);
            if (OLD_REG[7] != REG[7]) REG7.ForeColor = Color.Blue;
            else REG7.ForeColor = Color.Black;
            REG8.Text = String.Format("{0:X8}", REG[8]);
            if (OLD_REG[8] != REG[8]) REG8.ForeColor = Color.Blue;
            else REG8.ForeColor = Color.Black;
            REG9.Text = String.Format("{0:X8}", REG[9]);
            if (OLD_REG[9] != REG[9]) REG9.ForeColor = Color.Blue;
            else REG9.ForeColor = Color.Black;
            REG10.Text = String.Format("{0:X8}", REG[10]);
            if (OLD_REG[10] != REG[10]) REG10.ForeColor = Color.Blue;
            else REG10.ForeColor = Color.Black;
            REG11.Text = String.Format("{0:X8}", REG[11]);
            if (OLD_REG[11] != REG[11]) REG11.ForeColor = Color.Blue;
            else REG11.ForeColor = Color.Black;
            REG12.Text = String.Format("{0:X8}", REG[12]);
            if (OLD_REG[12] != REG[12]) REG12.ForeColor = Color.Blue;
            else REG12.ForeColor = Color.Black;
            REG13.Text = String.Format("{0:X8}", REG[13]);
            if (OLD_REG[13] != REG[13]) REG13.ForeColor = Color.Blue;
            else REG13.ForeColor = Color.Black;
            REG14.Text = String.Format("{0:X8}", REG[14]);
            if (OLD_REG[14] != REG[14]) REG14.ForeColor = Color.Blue;
            else REG14.ForeColor = Color.Black;
            if (Flag == 0)
            {
                REG15.Text = String.Format("{0:X8}", REG[15]);
                if (OLD_REG[15] != REG[15]) REG15.ForeColor = Color.Blue;
                else REG15.ForeColor = Color.Black;
            }
            else 
            { 
                REG15.Text = String.Format("{0:X8}", REG[16]);
                if (OLD_REG[15] != REG[15]) REG15.ForeColor = Color.Blue;
                else REG15.ForeColor = Color.Black;
            }
            REG17.Text = String.Format("{0:X8}", REG[17]);
            if (OLD_REG[17] != REG[17]) REG17.ForeColor = Color.Blue;
            else REG17.ForeColor = Color.Black;
            REG18.Text = String.Format("{0:X8}", REG[18]);
            if (OLD_REG[18] != REG[18]) REG18.ForeColor = Color.Blue;
            else REG18.ForeColor = Color.Black;
            for (i = 0; i < 19; i++)
            {
                OLD_REG[i] = REG[i];
            }
            return P3DBG_OK;
        }

        //=　レジスタリフレッシュボタン ==================================================================
        private void RegRefreshBtn_Click(object sender, EventArgs e)
        {
            RefreshFlag = 1;
        }
        //=　レジスタ書き換え ==================================================================
        private void REG0_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 0;
            RegSetFlag = 1;
        }
        private void REG1_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 1;
            RegSetFlag = 1;
        }
        private void REG2_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 2;
            RegSetFlag = 1;
        }
        private void REG3_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 3;
            RegSetFlag = 1;
        }
        private void REG4_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 4;
            RegSetFlag = 1;
        }
        private void REG5_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 5;
            RegSetFlag = 1;
        }
        private void REG6_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 6;
            RegSetFlag = 1;
        }
        private void REG7_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 7;
            RegSetFlag = 1;
        }
        private void REG8_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 8;
            RegSetFlag = 1;
        }
        private void REG9_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 9;
            RegSetFlag = 1;
        }
        private void REG10_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 10;
            RegSetFlag = 1;
        }
        private void REG11_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 11;
            RegSetFlag = 1;
        }
        private void REG12_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 12;
            RegSetFlag = 1;
        }
        private void REG13_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 13;
            RegSetFlag = 1;
        }
        private void REG14_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 14;
            RegSetFlag = 1;
        }
        private void REG15_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 15;
            RegSetFlag = 1;
        }

        private void REG17_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 17;
            RegSetFlag = 1;
        }

        private void REG18_DoubleClick(object sender, EventArgs e)
        {
            RegNo = 18;
            RegSetFlag = 1;
        }

    }
}
